/*******************************************************************************
*  skI2Clib - hQb֐Cu                                             *
*             ̃CuI2CfoCX(RTC/EEPROM)Ɛڑsׂ̊֐W  *
*                                                                              *
*    InterI2C       - hQb֘Å荞ݏ                                 *
*    InitI2C_Master - hQbʐM̃}X^[[hŏs             *
*    I2C_Start      - X[uɃX^[gRfBV𔭍s鏈           *
*    I2C_rStart     - X[uɃs[gEX^[gRfBV𔭍s鏈 *
*    I2C_Stop       - X[uɃXgbvRfBV𔭍s鏈           *
*    I2C_Send       - X[uɃf[^PoCgM鏈                   *
*    I2C_Receive    - X[uf[^PoCgM鏈                 *
*                                                                              *
*    I2C_SlaveRead  - X[ũfoCXw̃f[^ǂݍޏ     *
*    I2C_SlaveWrite - X[ũfoCXɎw̃f[^ޏ       *
*                                                                              *
*    FSDA/SCLs͕KufW^̓svɐݒsĉB         *
*          }`}X^[ɃoXՓ˂ꍇ́A"I2C_Start"đ *
*          SSP2𗘗pꍇ́AskI2Clib.h"#define I2C_MSSP2_USE"錾 *
*         __delay_us() and __delay_ms() gpĂ̂ "skI2CLCDlib.h"   *
*         "#define _XTAL_FREQ 16000000"LqĂA16MHzȊOCPUNbN*
*         ɂl͏܂傤B                                         *
* ============================================================================ *
*  VERSION DATE        BY                    CHANGE/COMMENT                    *
* ---------------------------------------------------------------------------- *
*  1.00    2012-01-20  ޒH[(ނ)  Create                            *
*  1.01    2013-02-16  ޒH[(ނ)  XC8 C Compiler ΉɕύX         *
*  2.00    2014-11-01  ޒH[(ނ)  }`}X^[ɑΉ              *
*  2.10    2015-03-04  ޒH[(ނ)  100/400KHzwɕύX    *
*  3.00    2015-04-20  ޒH[(ނ)  SSP1/SSP216F193xɑΉ      *
*  3.01    2015-07-19  ޒH[(ނ)  Rgǉ                      *
*  3.10    2016-07-15  ޒH[(ނ)  foCX̃WX^Ǐ֐ǉ*
*  3.20    2018-03-16  ޒH[(ނ)  FoscŎ؊ɕύX  *
* ============================================================================ *
*  PIC 12F1822 16F161x 16F18xx 16F193x 18F2xK22 18F26J50                       *
*  MPLAB X(v4.10)                                                              *
*  MPLAB(R) XC8 C Compiler Version 1.32/1.40                                   *
*******************************************************************************/
#include <xc.h>
#include "skI2Clib.h"

int AckCheck ;           // 肩ACK҂ptOϐ
int CollisionCheck ;     // ̃}X^[Ƃ̃oXՓˌoptOϐ

// AChԂ̃`FbN
// ACKEN RCEN PEN RSEN SEN R/W BF SĂOȂnj
void I2C_IdleCheck(char mask)
{
     while (( I2C_SSPCON2 & 0x1F ) | (I2C_SSPSTAT & mask)) ;
}
/*******************************************************************************
*  InterI2C( void )                                                            *
*    hQb(}X^[[h)֘Å荞ݏ                                  *
*     ̊֐̓CvO̊݊֐ŌĂт܂                         *
*******************************************************************************/
void InterI2C( void )
{
     if (I2C_SSPIF == 1) {       // SSP(I2C)荞ݔH
          if (AckCheck == 1) AckCheck = 0 ;
          I2C_SSPIF = 0 ;        // tONA
     }
     if (I2C_BCLIF == 1) {       // MSSP(I2C)oXՓˊ荞ݔH
          CollisionCheck = 1 ;
          I2C_BCLIF = 0 ;        // tONA
     }
}
/*******************************************************************************
*  InitI2C_Master(speed)                                                       *
*    hQbʐM̃}X^[[hŏs                              *
*                                                                              *
*    speed : I2C̒ʐMxw(0=100KHz 1=400KHz)                            *
*                                                                              *
*    )LNbN̂ݑΉÃNbNSSPADDύXKvL܂     *
*             4MHz  8MHz  16MHz  32MHz  40MHz  48MHz  64MHz                    *
*    100KHz   0x09  0x13   0x27   0x4F   0x63   0x77   0x9F                    *
*    400kHz         0x04   0x09   0x13   0x18   0x1D   0x27                    *
*    400KHz͎ۂɂ250KHzx͏oȂł傤A100KHz葬xł*
*    lĂΑx͑Ȃ܂vZxł͂ȂłB          * 
*******************************************************************************/
void InitI2C_Master(int speed)
{
     I2C_SSPSTAT= 0b10000000 ;     // Wx[h(X[[gOFF)ɐݒ肷(100kHz/1MHz)
     I2C_SSPCON1= 0b00101000 ;     // SDA/SCLsI2CŎgpA}X^[[hƂ
     if (speed == 0) {
#if _XTAL_FREQ == 64000000
          I2C_SSPADD = 0x9F  ;     // NbN=FOSC/((SSPADD + 1)*4) 64MHz/((0x9F+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x27  ;     // NbN=FOSC/((SSPADD + 1)*4) 64MHz/((0x27+1)*4)=0.4(400KHz)
#elif _XTAL_FREQ == 48000000
          I2C_SSPADD = 0x77  ;     // 48MHz/((0x77+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x1D  ;     // 48MHz/((0x1D+1)*4)=0.4(400KHz)
#elif _XTAL_FREQ == 40000000
          I2C_SSPADD = 0x63  ;     // 40MHz/((0x63+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x18  ;     // 40MHz/((0x18+1)*4)=0.4(400KHz)
#elif _XTAL_FREQ == 32000000
          I2C_SSPADD = 0x4F  ;     // 32MHz/((0x4F+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x13  ;     // 32MHz/((0x13+1)*4)=0.4(400KHz)
#elif _XTAL_FREQ == 16000000
          I2C_SSPADD = 0x27  ;     // 16MHz/((0x27+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x09  ;     // 16MHz/((0x09+1)*4)=0.4(400KHz)
#elif _XTAL_FREQ == 8000000
          I2C_SSPADD = 0x13  ;     // 8MHz/((0x13+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x04  ;     // 8MHz/((0x04+1)*4)=0.4(400KHz)
#else  // Fosc̏ꍇ͂ɎŐݒs
          I2C_SSPADD = 0x??  ;     // ??MHz/((0x??+1)*4)=0.1(100KHz)
     } else {
          I2C_SSPADD = 0x??  ;     // ??MHz/((0x??+1)*4)=0.4(400KHz)
#endif
          I2C_SSPSTAT_SMP = 0 ;    // x[h(X[[gON)ɐݒ肷(400kHz)
     }
     I2C_SSPIE = 1 ;               // SSP(I2C)荞݂
     I2C_BCLIE = 1 ;               // MSSP(I2C)oXՓˊ荞݂
     PEIE      = 1 ;               // ӑu荞݂
     GIE       = 1 ;               // S荞ݏ 
     I2C_SSPIF = 0 ;               // SSP(I2C)荞݃tONA
     I2C_BCLIF = 0 ;               // MSSP(I2C)oXՓˊ荞݃tONA
}
/*******************************************************************************
*  ans = I2C_Start(adrs,rw)                                                    *
*    X[uɃX^[gRfBV𔭍s鏈                            *
*                                                                              *
*    adrs : X[ũAhXw肵܂                                     *
*    rw   : X[uɑ΂铮̎w܂                                 *
*           0=X[uɏ݂Ȃv@1=X[uɑMȂv         *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂ) -1=̃}X^[Ƃ̃oXՓ˔  *
*******************************************************************************/
int I2C_Start(int adrs,int rw)
{
     CollisionCheck = 0 ;
     // X^[g(START CONDITION)
     I2C_IdleCheck(0x5) ;
     I2C_SSPCON2_SEN = 1 ;
     // [X[ũAhX]𑗐M
     I2C_IdleCheck(0x5) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_SSPBUF = (char)((adrs<<1)+rw) ;     // AhX + R/W𑗐M
     while (AckCheck) ;                      // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_SSPCON2_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_rStart(adrs,rw)                                                   *
*    X[uɃs[gEX^[gRfBV𔭍s鏈                  *
*                                                                              *
*    adrs : X[ũAhXw肵܂                                     *
*    rw   : X[uɑ΂铮̎w܂                                 *
*           0=X[uɏ݂Ȃv@1=X[uɑMȂv         *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂ) -1=̃}X^[Ƃ̃oXՓ˔  *
*******************************************************************************/
int I2C_rStart(int adrs,int rw)
{
     CollisionCheck = 0 ;
     // s[gEX^[g(REPEATED START CONDITION)
     I2C_IdleCheck(0x5) ;
     I2C_SSPCON2_RSEN = 1 ;
     // [X[ũAhX]𑗐M
     I2C_IdleCheck(0x5) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_SSPBUF = (char)((adrs<<1)+rw) ;     // AhX + R/W𑗐M
     while (AckCheck) ;                      // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_SSPCON2_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_Stop()                                                            *
*    X[uɃXgbvRfBV𔭍s鏈                            *
*    ans  :  0=                                                            *
*           -1=̃}X^[Ƃ̃oXՓ˔                                    *
*******************************************************************************/
int I2C_Stop()
{
     CollisionCheck = 0 ;
     // Xgbv(STOP CONDITION)
     I2C_IdleCheck(0x5) ;
     I2C_SSPCON2_PEN = 1 ;
     if (CollisionCheck == 1) return -1 ;
     else                     return  0 ;
}
/*******************************************************************************
*  ans = I2C_Send(dt)                                                          *
*    X[uɃf[^PoCgM鏈                                    *
*                                                                              *
*    dt  : Mf[^w肵܂                                          *
*    ans  : 0=                                                             *
*           1=ُ(肩ACKԂĂȂNOACKԂ)                 *
*          -1=̃}X^[Ƃ̃oXՓ˔                                     *
*******************************************************************************/
int I2C_Send(char dt)
{
     CollisionCheck = 0 ;
     I2C_IdleCheck(0x5) ;
     if (CollisionCheck == 1) return -1 ;
     AckCheck = 1 ;
     I2C_SSPBUF = dt ;                  // f[^𑗐M
     while (AckCheck) ;                 // 肩ACKԓ҂
     if (CollisionCheck == 1) return -1 ;
     return I2C_SSPCON2_ACKSTAT ;
}
/*******************************************************************************
*  ans = I2C_Receive(ack)                                                      *
*    X[uf[^PoCgM鏈                                  *
*                                                                              *
*    ack  : X[uւ̕ԓf[^w肵܂                                 *
*           0:ACKԂ@1:NOACKԂ(Mf[^ŌȂ1)                  *
*    ans  : Mf[^Ԃ                                               *
*           -1=̃}X^[Ƃ̃oXՓ˔                                    *
*******************************************************************************/
int I2C_Receive(int ack)
{
     int dt ;

     CollisionCheck = 0 ;
     I2C_IdleCheck(0x5) ;
     I2C_SSPCON2_RCEN = 1 ;           // M
     I2C_IdleCheck(0x4) ;
     if (CollisionCheck == 1) return -1 ;
     dt = I2C_SSPBUF ;                // f[^̎M
     I2C_IdleCheck(0x5) ;
     if (CollisionCheck == 1) return -1 ;
     I2C_SSPCON2_ACKDT = ack ;        // ACKf[^̃Zbg
     I2C_SSPCON2_ACKEN = 1 ;          // ACKf[^Ԃ
     return dt ;
}
/*******************************************************************************
*  ans = I2C_SlaveRead(slv_adrs,reg_adrs,*data,kosu)                           *
*  X[ũfoCXw̃f[^ǂݍޏ                        *
*  }`}X^[ɑΉĂ܂B                                            *
*                                                                              *
*    slv_adrs : X[ũfoCXAhXw肵܂(7bitŎw)             *
*    reg_adrs : Ǐof[^̃WX^[AhXw肵܂                   *
*               AIɓǏoꍇ́AǏoWX^[̐擪AhXw     *
*    *data    : Ǐof[^̊i[w肵܂                             *
*    kosu     : Ǐof[^̃oCgw肵܂                             *
*    ans      : 0=@1=ُ(肩ACKԂĂȂ)                      *
*              -1=̃}X^[Ƃ̃oXՓ˂ăgCI[o[           *
*******************************************************************************/
int I2C_SlaveRead(int slv_adrs,char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i , ack , j ;

     for (j=0 ; j<BUS_COLLISION_RETRY ; j++) {
          ans = I2C_Start(slv_adrs,RW_0);              // X^[gRfBV𔭍s
          if (ans == 0) {
               I2C_Send(reg_adrs) ;                    // WX^AhXw
               ans = I2C_rStart(slv_adrs,RW_1) ;       // s[gEX^[gRfBV𔭍s
               if (ans == 0) {
                    for (i=1 ; i<=kosu ; i++) {
                         if (i==kosu) ack = NOACK ;
                         else         ack = ACK ;
                         *data = I2C_Receive(ack);     // wǂݏo(M)
                         data++ ;
                    }
               }
          }
          I2C_Stop() ;                                 // XgbvRfBV𔭍s
          if (ans != -1) break ;                       // oX̏ՓˈȊOȂI
          else {
               for (i=0 ; i<10 ; i++) {
                    __delay_ms(10) ;                   // oX̏Փ˂100msɃgC
               }
          }
     }
     return ans ;
}
/*******************************************************************************
*  ans = I2C_SlaveWrite(slv_adrs,reg_adrs,*data,kosu)                          *
*  X[ũfoCXɎw̃f[^𑗐M鏈                          *
*  }`}X^[ɑΉĂ܂B                                            *
*                                                                              *
*    slv_adrs : X[ũfoCXAhXw肵܂(7bitŎw)             *
*    reg_adrs : of[^̃WX^[AhXw肷                     *
*               AIɏoꍇ́AoWX^[̐擪AhXw     *
*    *data    : of[^̊i[w肷                                 *
*    kosu     : of[^̃oCgw肷                               *
*    ans      : 0=@1=ُ(肩ACKԂĂȂ)                      *
*              -1=̃}X^[Ƃ̃oXՓ˂ăgCI[o[           *
*******************************************************************************/
int I2C_SlaveWrite(int slv_adrs,char reg_adrs,unsigned char *data,char kosu)
{
     int  ans , i , j ;

     for (j=0 ; j<BUS_COLLISION_RETRY ; j++) {
          ans = I2C_Start(slv_adrs,RW_0);         // X^[gRfBV𔭍s
          if (ans == 0) {
               I2C_Send(reg_adrs) ;               // WX^AhXw
               for (i=0 ; i<kosu ; i++) {
                    I2C_Send(*data) ;             // w(M)
                    data++ ;
               }
          }
          I2C_Stop() ;                            // XgbvRfBV𔭍s
          if (ans != -1) break ;                  // oX̏ՓˈȊOȂI
          else {
               for (i=0 ; i<10 ; i++) {
                    __delay_ms(10) ;              // oX̏Փ˂100msɃgC
               }
          }
     }
     return ans ;
}
